#!/usr/bin/perl
# questo script serve per aggiungere una riga ai messaggi

# leggi directory dello script
$0 =~ /(.*)(\\|\/)/;
chdir $1;

# file contenente i messaggi (in HTML formattato)
$messaggi = "messaggi.txt"; 

# file log (non usato)
# $logfile = "$dir/logfile.txt";

# locazione dello script di visualizzazione
$script = "chat.pl"; 


# legge parametri con GET
$params = $ENV{'QUERY_STRING'};

# divide i parametri
&parseparams;

# test che i campi non siano vuoti
if (!$fields{xnome} || !$fields{xtesto})
{
  &visualizza;
}
  
# legge la data
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
if ($min < 10) {
      $min = "0$min";
   }
$date = "$mday $hour:$min";

# scrive messaggio nel file
$hostname = $ENV{'REMOTE_HOST'};
open (DATABASE, ">>$messaggi") || die ("errore apertura file");
flock (DATABASE,2);
seek(DATABASE,0,2); # cursore alla fine del file
print DATABASE "$date <B>$fields{xnome}</B> : <font color=\"$fields{colore}\">$fields{xtesto}</font><!-- $hostname --><br>\n";
close (DATABASE);
	
#        if (open (DATABASE, ">>$logfile"))
#        {
#	  print DATABASE "$fields{xtesto}\n";
#	  close (DATABASE);
#	}
&visualizza;

sub visualizza
{
# ridireziona il browser per visualizzare messaggi
  print "Location: $script\r\n\r\n";
  exit 0;
}

sub parseparams
{
  my $name,$value,@pairs;
  
  @pairs=split(/&/,$params);
  foreach $item(@pairs) {
	($name,$value)=split (/=/,$item,2);
	# converte + in ' '
	$value=~tr/+/ /;
	# converte valori in esadecimale
        $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
        # toglie commenti in HTML
        $value =~ s/<!--(.|\n)*-->//g;
        # toglie TAG HTML
        $value =~ s/<([^>]|\n)*>//g;
        # toglie a capo
        $value =~ s/\n//g;
	$fields{$name}=$value;
  }
}
