#use wml::fmt::text

<perdrversion version="0.0108b" date="08 Oct 2006" auto="0.0108">
<text>
 - from patch from Jason Hood:
  - recognise float types (ByteInfo::typeFloat)
  - allow -1 in arrays
  - added the functions to dump raw bytes and output C-escaped strings
  - added more instructions to GetUseType (adapted)
  - Windows API function argument reference (winapifn.lst file)
  - custom function aliases and arguments (customfn.lst file)
  - comparison instructions will use condition codes, other instructions flags
   (eg: "cmp eax, 0" / "je ADDR", but "test eax, eax" / "jz ADDR")
  - made the "Referenced by" output an option, instead just using delineators to
   indicate calls ("========") and jumps/constants ("--------"), also indicating
   how many forward/backward references (eg: "=1<=2>==" means this function is
   called once before this address and twice after)
 - mark reference detected in complex reference and use them
 - dump even data
 - update floating point disassembly (up to Pentium 4)
</text>
</perdrversion>

<perdrversion version="0.0107b" date="03 Oct 2006" auto="0.0107">
<text>
 - from patch from Jason Hood:
  - if there are no code sections, treat the section containing EP as code
  - primitive recognition of Unicode strings (`(StringData)L"unicode"')
   !!! WONDERFUL !!!
  - display only the first 100 characters of strings
  - if the instruction is 11 bytes, keep the bytes on one line
  - display strings using "StringZ" pseudo-instruction (adapted)
  - display base address using 2, 4 or 8 digits, depending on its value
  - add a tab after BYTE/WORD/DWORD
  - made the REP actual prefixes for string instructions (eg: "rep movsb")
  - added short options for most of the long
  - added --show-cRef for the original "Referenced by" display (calls)
  - added --show-URef for the original "Referenced by" display (uncond. jumps)
  - added --show-CRef for the original "Referenced by" display (cond. jumps)
  - added --show-refs for the original "Referenced by" display (all of above)
  - add space after each colon in DLL display (eg: "Addr:xxx" -> "Addr: xxx")
  - minor fixes
 - added --no-entry-code options to specify that entry point does not
   point to code (happen with some driver)

 For developers
 - add GetLiteralSize support for offsets in Param
 - add Instruction::IsNop (adapted from Jason patch)
</text>
</perdrversion>

<perdrversion version="0.0106b" date="26 Sep 2006" auto="0.0106">
<text>
 - from patch from Jason Hood:
  - reduced the file header, added option for original display
  - dump known resource types, added option for original display
  - use three columns to display relocations
  - added space after the comma (eg: "mov al, 0")
  - only use "repe" (and "repne", not "repnz") when appropriate, "rep" otherwise
  - made the REP actual prefixes for string instructions (eg: "rep movsb")
  - "normalised" the condition codes
  - added --full-headers(-H) for the original headers display
  - added --raw-resources(-R) for the original resource display
  - replace "Ord." with "Ord#"

 For developer
 - changed GetStringStats to IsPossibleString
</text>
</perdrversion>

<perdrversion version="0.0105b" date="21 Sep 2006" auto="0.0105">
<text>
 - from patch from Jason Hood:
  - BUG FIX: fix crash fix crash when importing by ordinal
  - BUG FIX: some typo fix
  - BUG FIX: PUNPCKLDQ was stored as PUNOCKLDQ
  - BUG FIX: FEMMS & PREFETCH (swapped opcodes)
  - BUG FIX: MOVLPS (swapped src/dst)
  - BUG FIX: PACKSSWB (was PACKUSDW)
  - BUG FIX: PACKUSWB (was PACKSSWB)
  - BUG FIX: ARPL (EwGw not EvGv)
  - BUG FIX: FUCOMPP (was FUCOMPUU)
  - TEST/XCHG ("mem,reg" instead of "reg,mem")
  - improve a lot disasm adding SSE/SSE2
  - start float handling
  - enhanced x86test (read from file, read bytes on command line)
 - BUG FIX: read correctly across sections
 - enable warning if compiled with gcc
 - do not use CFLAGS/CXXFLAGS in configure
</text>
</perdrversion>

<perdrversion version="0.0104b" date="04 Jan 2004" auto="0.0104">
<text>
 - fix dll search under win32
</text>
</perdrversion>

<perdrversion version="0.0103b" date="21 May 2003" auto="0.0103">
<text>
 - BUG FIX: DevC++ produced buggy executable
 - ADD: --addr-start --addr-end options to disassemble partially

 For developer
 - Rewritten options code
</text>
</perdrversion>

<perdrversion version="0.0102b" date="2 February 2003" auto="0.0102">
<text>
 - BUG FIX: do not try to search full api name for export
 - ADD: print possible strings references
   (idea and partial implementation from Jeremy Smith)
 - ADD: find external dll to read full api names (if ordinal)
   (used current directory on Unix, SearchPath on windows)

 For developer
 - OutOfAddress is now global
 - cleanup and constification
 - new ::DataReader class (removing dependency for dasm)
 - renames ReadByte/Word/Dword in ReadU8/U16LE/U32LE (now only on DataReader)
</text>
</perdrversion>

<perdrversion version="0.0101b" date="1 January 2003" auto="0.0101">
<text>
 - updated DevC++ project
 - BUG FIX: print wrong disassembly on some cases (without -b option)
 - a bit faster

 For developer
 - renamed api to symbol and FileByte to ObjectModule
 - review Relocation classes for bfd use
 - move Symbols and entryPoint infos into ObjectModule
 - many cleanup
 - new mode to read object (ObjectModule::DataReader class)
</text>
</perdrversion>

<perdrversion version="0.0100b" date="1 August 2002" auto="0.0100">
<text>
 - ADD: add ws2_32 to cache
 - BUG FIX: fix overlapped instruction printing output
 - BUG FIX: filler skip relocation on 0 byte sequences
 - BUG FIX: fix overlapping beetween code and data
</text>
</perdrversion>

<perdrversion version="0.0099b" date="29 July 2002" auto="0.0099">
<text>
- ADD: print import name if imported by ordinal
- BUG FIX: if unknown data contain relocation are printed as DWORD, not single
  bytes (this is the main reason for this fast release)
</text>
</perdrversion>

<news date="28 July 2002">
 - updated site layout
</news>

<perdrversion version="0.0098b" date="25 July 2002" auto="0.0098">
<text>
 - removed ole2 and added odbc32 from cache
 - print hexadecimal file characteristics
 - print more flag of file characteristics
 - filled some missing directory names
</text>
</perdrversion>

<perdrversion version="0.0097b" date="13 July 2002">
<text>
 - BUG FIX: correct spelling in README
 - ADD: for some dll (wsock32, ole32, oleaut32 for the moment) show imports name
  even if imported by ordinal (for now cached in executable)
</text>
</perdrversion>

<perdrversion version="0.0096b" date="2 July 2002">
<text>
 - BUG FIX: wrong check if byte occupied
   (I promise I'll always do regression test from now on :) )
 - BUG FIX: some spell fix on doc and syntax usage
</text>
</perdrversion>

<perdrversion version="0.0095b" date="16 June 2002">
<text>
 - ADD: add option to select what output
   (useful for script or other things)
 - show decimal and hex for ordinals
 - update man page

 For developer
 - fix make distcheck
 - add GUI to dist (still in alpha)
</text>
</perdrversion>

<perdrversion version="0.0094b" date="12 June 2002">
<text>
 - Projects for DevC++ (console and GUI)
 - Project for Anjuta 1.9 (console)
 - begin GUI (some preliminary code only)
 - BUG FIX: import without Hint-Name handled correctly (Borland and early Microsoft compiler)

 For developer:
 - moved some utils file to a new directory
 - transform many defines to enum
</text>
</perdrversion>

<perdrversion version="0.0093b" date="18 March 2002">
<text>
- BUG FIX: fix len check marking data
- ADD: option for icon extraction
- test for little endian during compilation
</text>
</perdrversion>

<perdrversion version="0.0092b" date="10 December 2001">
<text>
- BUG FIX: fix compile problem with VC++ in release mode (severe BUG)
- some file cleanup
</text>
</perdrversion>

<perdrversion version="0.0091b" date="9 December 2001">
<text>
- BUG FIX: do not collapse symbols for same address
</text>
</perdrversion>

<perdrversion version="0.009b" date="29 November 2001">
<text>
- BUG FIX: unicode handling fixed if wchar_t is not 16bit unicode
- BUG FIX: invalid esc decode instruction (small 0.0089 only bug)
- some cleanup
- fixed some missed include
</text>
</perdrversion>

<perdrversion version="0.0089b" date="28 October 2001">
<text>
 - started redesign code
</text>
</perdrversion>

<perdrversion version="0.0088b" date="24 June 2001">
<text>
 - NEWS: project ported to SourceForge (perdr.sourceforge.net)
 - BUG FIX: fixed priority for complex memory references
 - BUG FIX: raw-dump rewind file for empty section
 - BUG FIX: fixed relocation detection with some strange file
 - BUG FIX: fixed small problem with MSVC compiler
 - disabled unsafe heuristic, too unsafe
 - improved config scripts
</text>
</perdrversion>

<perdrversion version="0.0087b" date="10 March 2001">
<text>
 - BUG FIX: invalid SECC instruction reported as valid
 - BUG FIX: removed overwriting information with bad one marking integer
 - import marked as loader bytes
 - added Borland C++ project files to source

 For developer:
 - some cleanup in code
 - added note.txt to source
</text>
</perdrversion>



<perdrversion version="0.0086b" date="25 February 2001">
<text>
 - BUG FIX: removed log print
 - BUG FIX: missing some list item separator in man page
 
 For developer:
 - removed silly dependency from peformat.h
 
 Notes:
 - This project is not dead! I'm the only programmer and every single 
   problem can slow down developing!
</text>
</perdrversion>


<perdrversion version="0.0085b" date="21 December 2000">
<text>
 - BUG FIX: removed some wrong relocation checking (3D Now! and SECC1)
 - BUG FIX: checked memory parameter for 3D Now!
 - BUG FIX: correct too restrictive debug check (stupid mistake)
 - BUG FIX: incorrect cvtpi2ps handling
 - Fixed some constant for performance and size optimization

For developer:
 - renamed inst_offset to pc
 - revisited pc handling in x86dasm
 - removed bit field from PE structure
</text>
</perdrversion>

<perdrversion version="0.0084b" date="5 December 2000">
<text>
 - ADD: finished all Pentium III instructions
 - ADD: Athlon instruction and parameter
 - ADD: --raw-dump parameter

For developer:
 - removed old C style code
 - RelocationInfo associated with FileByte
</text>
</perdrversion>

<perdrversion version="0.0083b" date="18 November 2000">
<text>
 - ADD: man page for UNIX
 - .spec file use rpm global options
 - small precision improvement

For developer:
 - many changes to encapsulate old style C code to object oriented
 - preparing to merge with bdf (now code is GPL, so I can include bdf 
   without license problem)

Note:
 - there are no BUG FIX in this version!
 - why I waited for so many time ?
   - I had many other work (and other problem too)
   - I studied other freeware project for merging or optimize my work 
     (bdf, DCC, PEDasm and others)
 
</text>
</perdrversion>

<perdrversion version="0.0082beta" date="2 September 2000">
<text>
 - BUG FIX: fixed data resided in two section
 - BUG FIX: bad address reference for some complex reference
 - BUG FIX: bad label marking for some jmp dword ptr [x*4+y] reference
 - BUG FIX: some minor correction
 - print information on complex reference
 - if bad parameters print usage and return error
 - added some instruction processing

For developer:
 - Fixed TIstrInfos constant use
</text>
</perdrversion>

<perdrversion version="0.008beta" date="August 26th 2000">
<text>
 - BUG FIX: not infinite loop for some overlapped code (rarest)
 - BUG FIX: don't overwrite priority on data
 - BUG FIX: correct condition on heuristic motor
 - BUG FIX: not relocation on string!
 - rewrite auto_ptr (more compatible)
 - rewrite some PE structure (more compatible)

For developer:
 - separate complex reference analysis from code.cpp to codescan.cpp
 - eliminate TCodeRange class (not used)
 - renamed export identifier (keyword on some compiler)
 - fix table for registry information (x86reg)
</text>
</perdrversion>

<perdrversion version="0.0075beta" date="June 10th 2000">
<text>
 - Source code released.
</text>
</perdrversion>

<perdrversion version="0.0075beta" date="March 22th 2000">
<text>
 - BUG FIX: not extend sign on byte constant for byte registry operation
 - ADD: add --show-priority to options
</text>
</perdrversion>

<perdrversion version="0.007beta" date="March 12th 2000">
<text>
 - BUG FIX: wrong priority order
 - BUG FIX: no overlapped code
 - BUG FIX: fixed loader data exclusion on some file
 - ADD: Added global reference to heuristic motor
</text>
</perdrversion>

<perdrversion version="0.006beta" date="February 14th 2000">
<text>
 - BUG FIX: xchg eax,ebx printed as xchg ax,ebx
 - BUG FIX: internal uninitialized error (3 day of work!!)
 - BUG FIX: fixed some insignificant memory leak
 - ADD: instruction movntq (found AMD doc)
 - ADD: jmp dword [4*reg+constant] improved
 - ADD: start global analysis
 - some optimization
</text>
</perdrversion>

<perdrversion version="0.005beta" date="January 17th 2000">
<text>
I start revision program output
 - BUG FIX: string/loader data length not reported correctly
 - BUG FIX: loader data not handle correctly
 - BUG FIX: resource with name handled as ID
 - BUG FIX: overflow on section name printing
 - BUG FIX: segment override not printed
 - BUG FIX: print [] if param is [00000000h]
 - BUG FIX: if [xxx] xxx constant write always unsigned
 - BUG FIX: if file has no relocation handled as with relocation
 - ADD: option for version and processor disabling
</text>
</perdrversion>

<perdrversion version="0.004beta" date="January 11th 2000">
<text>
 - BUG FIX: cmpxcghg8b have bad parameter
 - ADD: Pentium III control instruction (prefetchX, fxsave, fxrstor, 
   ldmxcsr, stmxcsr, sysenter, sysexit, sfence)
 - ADD: Pentium III MMX instruction (maskmovq, pextrw, pmovmskb, pavgb, 
   pavgw, pinsrw, pminub, pminsw, pmaxub, pmaxsw, pmulhuw, psadbw, 
   pshufw)
 - ADD: full AMD 3DNow! instruction extension
</text>
</perdrversion>

<perdrversion version="0.003beta" date="January 8th 2000">
<text>
 - BUG FIX: Correct disassembly for Imm8 signed extended, now extend sign
 - BUG FIX: Wrong size setting of memory
 - ADD: Excluded loader code
 - ADD: Added api call to heuristic motor
</text>
</perdrversion>

<perdrversion version="0.002beta" date="January 4th 2000">
<text>
 - BUG FIX: Relocation on instruction not handled correctly
 - BUG FIX: More label than needed
 - BUG FIX: String are now handled correctly
 - BUG FIX: No code and code overlap on complex jmp
 - ADD: Relocation on code finished
 - ADD: Options (--bytes)
 - ADD: Better data analysis
</text>
</perdrversion>

<perdrversion version="0.001beta" date="January 1th 2000">
<text>
 - BUG FIX: Don't add many reference
 - BUG FIX: Not initialized data pointer are not correct
 - ADD: relocation use
</text>
</perdrversion>

<perdrversion version="0.00015beta" date="November 19th 1999">
<text>
 - BUG FIX: Don't exit if some instruction is unknown
 - BUG FIX: fixed error printing Numeric export
 - ADD: data analysis for pointer in code
 - ADD: check for string in code - many new BUG :-)
</text>
</perdrversion>

<perdrversion version="0.0001beta" date="November 25th 1999" />

<perdrversion version="0.00001beta" date="November 11th 1999" />


